#!/usr/bin/env bash
##~---------------------------------------------------------------------------##
##                        _      _                 _   _                      ##
##                    ___| |_ __| |_ __ ___   __ _| |_| |_                    ##
##                   / __| __/ _` | '_ ` _ \ / _` | __| __|                   ##
##                   \__ \ || (_| | | | | | | (_| | |_| |_                    ##
##                   |___/\__\__,_|_| |_| |_|\__,_|\__|\__|                   ##
##                                                                            ##
##  File      : do_update_npm.sh                                              ##
##  Project   : my_computer_tidy_and_clean                                    ##
##  Date      : Feb 24, 2020                                                  ##
##  License   : GPLv3                                                         ##
##  Author    : stdmatt <stdmatt@pixelwizards.io>                             ##
##  Copyright : stdmatt 2020                                                  ##
##                                                                            ##
##  Description :                                                             ##
##                                                                            ##
##---------------------------------------------------------------------------~##

##----------------------------------------------------------------------------##
## Imports                                                                    ##
##----------------------------------------------------------------------------##
source /usr/local/src/stdmatt/shellscript_utils/main.sh


##----------------------------------------------------------------------------##
## Packages                                                                   ##
##----------------------------------------------------------------------------##
##------------------------------------------------------------------------------
PACKAGES="vsce      \
          npm       \
          ";

##----------------------------------------------------------------------------##
## Functions                                                                  ##
##----------------------------------------------------------------------------##
##------------------------------------------------------------------------------
install_packages()
{
    for PACKAGE in $PACKAGES; do
        sudo npm install -g "$PACKAGE";
    done;
}

##------------------------------------------------------------------------------
ensure_npm()
{
    test -n "$(pw_get_program_path npm)" && return;

    pw_FG "--> Installing NPM <--";
    case "$(pw_os_get_simple_name)" in
        "$(PW_OS_GNU_LINUX)" )
            curl -sL https://deb.nodesource.com/setup_14.x | sudo -E bash -
            sudo apt-get install -y npm nodejs
            ;;
        "$(PW_OS_WSL)"       )
            curl -sL https://deb.nodesource.com/setup_14.x | sudo -E bash -
            sudo apt-get install -y npm nodejs
            ;;
        "$(PW_OS_OSX)" )
            brew install node
            ;;
    esac;
}

##----------------------------------------------------------------------------##
## Script                                                                     ##
##----------------------------------------------------------------------------##
ensure_npm;
install_packages;
